function parseString(identifier) {
    var pieces = identifier.split("#");

    return {
        module: pieces.shift(),
        object: pieces.join()
    };
}

function stringify(identifier) {
    if (typeof identifier == "string") {
        return identifier;
    }

    return identifier.module + "#" + identifier.object;
}

exports.load = function load(identifier) {
    if (typeof identifier == "string") {
        identifier = parseString(identifier);
    }

    var object = require(identifier.module);
    var properties = (identifier.object || "").split(".");

    for (var i = 0, l = properties.length; i < l; ++i) {
        if (properties[i]) {
            object = object[properties[i]];

            if (!object) {
                throw new TypeError(stringify(identifier) + " is null or undefined");
            }
        }
    }

    return object;
};
